widget_vincentdjango/announcements/urls.py
from django.urls import path
from .views import index, AnnouncementsDetailView, AnnouncementsCreateView, AnnouncementsUpdateView

urlpatterns = [
    path('', index, name='index'),
    path('announcements/<int:pk>/details', AnnouncementsDetailView.as_view(), name='announcements-detail'),
    path('announcements/add', AnnouncementsCreateView.as_view(), name = 'announcements-add'),
    path('announcements/<int:pk>/edit', AnnouncementsUpdateView.as_view(), name = 'announcements-edit')
]


app_name = "announcements"

widget_vincentdjango/assignments/urls.py
from django.urls import path
from .views import homeAssignmentsPage, AssignmentsDetailView, AssignmentsUpdateView, AssignmentsCreateView

urlpatterns = [
    path('', homeAssignmentsPage, name='homePage'),
    path('add/', AssignmentsCreateView.as_view(), name='assignment_add'),
    path('<int:pk>/details/', AssignmentsDetailView.as_view(), name='assignment_details'),
    path('<int:pk>/edit/', AssignmentsUpdateView.as_view(), name='assignment_update'),
]

app_name = "assignments"

widget_vincentdjango/forum/urls.py
# forum/urls.py
from django.urls import path

from .views import index, ForumPostDetailView, ForumPostCreateView, ForumPostUpdateView

urlpatterns = [
    path('', index, name='index'),
    path('forumposts/<int:pk>/details', ForumPostDetailView.as_view(), name='forumpost-details'),
    path('forumposts/add', ForumPostCreateView.as_view(), name='forumpost-add'),
    path('forumposts/<int:pk>/edit', ForumPostUpdateView.as_view(), name='forumpost-edit'),
]

# This might be needed, depending on your Django version
app_name = "forum"

widget_vincentdjango/widget_vincentdjango/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('dashboard.urls', namespace="dashboard")),
    path('calendar/', include('widget_calendar.urls', namespace="widget_calendar")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('forum/', include('forum.urls', namespace="forum")),
]

widget_vincentdjango/announcements/models.py
from django.db import models
from dashboard.models import WidgetUser
from django.urls import reverse


class Announcement(models.Model):
    title = models.CharField(max_length=250, default="")
    body = models.TextField(null=True, blank=True)
    author = models.ForeignKey(
        WidgetUser,
        null=True, 
        default=True, 
        on_delete=models.CASCADE,
        related_name='announcements',
    )
    pub_datetime = models.DateTimeField(auto_now_add=True, editable=False)

    def __str__(self):
        return self.title
    
    def format_pub_datetime(self):
        return self.pub_datetime.strftime('%m/%d/%Y, %I:%M %p')
    
    def get_absolute_url(self):
        return reverse('announcements:announcements-detail', kwargs={'pk': self.pk})

class Reaction(models.Model):
    name = models.CharField(max_length=5, choices=[('Like', 'Like'), 
                                                   ('Love', 'Love'), 
                                                   ('Angry', 'Angry')], default='Like')
    tally = models.PositiveIntegerField(default=0)
    announcement = models.ForeignKey(
        Announcement, 
        null=True, 
        default=True, 
        on_delete=models.CASCADE,
        related_name='reactions'
    )

    def __str__(self):
        return self.name
    

widget_vincentdjango/announcements/views.py
from django.shortcuts import render
from django.http import HttpResponse
from .models import Announcement
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView
from dashboard.models import WidgetUser

def index(request):
    announcements = Announcement.objects.all()
    return render(request, 'announcements/announcements.html', {'announcements':announcements})

class AnnouncementsDetailView(DetailView):
    model = Announcement
    template_name = 'announcements/announcement-details.html'

class AnnouncementsCreateView(CreateView):
    model = Announcement
    template_name = 'announcements/announcement-add.html'
    fields = ["title", "body", "author"]

class AnnouncementsUpdateView(UpdateView):
    model = Announcement
    template_name = 'announcements/announcement-edit.html'
    fields = '__all__'

widget_vincentdjango/announcements/templates/announcements/announcement-add.html
{% extends 'base.html' %}
{% load static %}

{% block title %} Add Announcement {% endblock %}
{% block heading %}
	<h1 class="subheader"> Add a new announcement: </h1>
{% endblock %}
{% block content %}
    <form method="post">
        {% csrf_token %}
        {{ form.as_p }}
        <div class="separator-bar"></div>
		<input class="action-button" type="submit" value="Add Announcement">
    </form>
{% endblock %}

widget_vincentdjango/announcements/templates/announcements/announcement-details.html
{% extends 'base.html' %}
{% load static %}

{% block title %} {{ object.title }} {% endblock %}
{% block heading %}
    <h1> {{ object.title }} </h1>
    <h2> by {{ object.author.first_name }} {{ object.author.last_name }} </h2>
    <h4> {{ object.format_pub_datetime }} </h4>
    <p class="detail-body"> {{ object.body }} </p>

    <div class="separator-bar"></div>
    {% for reaction in object.reactions.all %}
        <p class="detail-additionalinfo">
            {{ reaction.name }}: {{ reaction.tally }}
        </p>
    {% endfor %}
    <div class="separator-bar"></div>
    <button class="action-button" onclick="window.location.href='{% url 'announcements:announcements-edit' pk=object.pk %}'">
        Edit Announcement
    </button>
{% endblock %}

widget_vincentdjango/announcements/templates/announcements/announcement-edit.html
{% extends 'base.html' %}
{% load static %}

{% block title %} Edit Anouncement {% endblock %}
{% block heading %}
	<h1 class="subheader"> Edit Announcement: </h1>
{% endblock %}
{% block content %}
	<form method="post">
		{% csrf_token %}
		{{ form.as_p }}
		<br>
        <div class="separator-bar"></div>
		<input class="action-button" type="submit" value="Save Changes to Announcement">
	</form>
{% endblock %}

widget_vincentdjango/announcements/templates/announcements/announcements.html
{% extends 'base.html' %}
{% load static %}

{% block title %} Widget's Announcement Board {% endblock %}
{% block heading %}
    <h1 id="header"> Welcome to Widget's Announcement Board! </h1>
{% endblock %}
{% block content %}
    <h2 class="subheader"> Announcements: </h2>
    <ul>
            {% for object in announcements|dictsortreversed:"pub_datetime" %}
            <li class="object-cell">
                <a href="{{ object.get_absolute_url }}"> <span class="object-title">{{ object.title }}</span> by 
                    {{ object.author.first_name}} {{ object.author.last_name }}
                </a>
            </li>
            {% endfor %}
    </ul>
	<hr>
	<button onclick="window.location.href='{% url 'announcements:announcements-add' %}'" class="action-button">
        New Announcement
    </button>
    <div id="footer">
        <a href="{% url 'dashboard:index' %}">Dashboard</a>
        <a href="{% url 'forum:index' %}">Forum</a>
        <a href="{% url 'assignments:homePage' %}">Assignments</a>
        <a href="{% url 'widget_calendar:index' %}">Calendar</a>
    </div>

{% endblock %}